package main.java;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;
import java.io.File;
import main.java.EmployeeData;
import main.java.Employees;


/*
* Class to check marshall and unmarshall
*/
public class JAXBExample{
	public static void main(String args[]){
		// Create the employee list
		Employees empList = new Employees();
		EmployeeData data1 = new EmployeeData("1","Charlie","Chaplin",35,2000.00);
		EmployeeData data2 = new EmployeeData("2","John","Rambo",36,2500.00);
		empList.add(data1);
		empList.add(data2);
		
		try{
			// Marshall
			JAXBContext jaxbContext = JAXBContext.newInstance(Employees.class);
			Marshaller marshaller = jaxbContext.createMarshaller();
			marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, true);
			marshaller.marshal(empList, new File("employee.xml"));
			marshaller.marshal(empList, System.out);	

			// Unmarshall
			File file = new File("employee.xml");
			jaxbContext = JAXBContext.newInstance(Employees.class);
			Unmarshaller unmarshaller = jaxbContext.createUnmarshaller();
			empList = (Employees) unmarshaller.unmarshal(file);
			System.out.println(empList);		
			
		} catch (JAXBException jaxbe){
			jaxbe.printStackTrace();
		} catch (Exception fnfe) {
			fnfe.printStackTrace();
		}
	}
}
